/*
*  HelpDlgs.cpp
*  Copyright  1999-2006 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\clipbrd.hpp>
#include <vcl\classes.hpp>
#pragma hdrstop

#include "HelpDlgs.h"
#include "Global.h"
#include "FileMan.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
const AnsiString HlpCap = "Help!";
const AnsiString HelpStayOnTop = "HelpStayOnTop";
const AnsiString AppQSdbc = AppDir+"QS.dbc";
THelpDlg *HelpDlg;
//---------------------------------------------------------------------------
void __fastcall OpenHelp2(AnsiString &Sections, AnsiString &Title, AnsiString &ActiveTab)
{
   HelpDlg = new THelpDlg((TForm*)NULL,Sections,Title,ActiveTab);
   HelpDlg->Show();
}
//---------------------------------------------------------------------------
void __fastcall OpenHelp(AnsiString &Section, AnsiString &Title,
   AnsiString &ActiveTab, TForm *Owner)
{
   HelpDlg = new THelpDlg(Section,Title,ActiveTab,NULL);
   HelpDlg->Show();
}
//---------------------------------------------------------------------------
void __fastcall OpenHelpTopics(AnsiString &Topics, TForm *Owner)
{
   HelpDlg = new THelpDlg(Topics,NULL);
   HelpDlg->Show();
}
//---------------------------------------------------------------------------
AnsiString __fastcall QSHelp()
{
   if (FileExists(QShelp)) return QShelp;
   return AppDir+"\\doc\\"+ExtractFileName(QShelp);
}
//---------------------------------------------------------------------------
__fastcall THelpDlg::THelpDlg(TComponent* Owner)
  : TForm(Owner)
{
   //StayOnTop->Checked = GetAppIni(HelpStayOnTop,"").ToIntDef(1)==1;
   //FormStyle = StayOnTop->Checked ? fsStayOnTop : fsNormal;
   owner = (TForm*)Owner;

   if (Owner) CenterDialog(this,owner);
   tabs = new TStringList();
   Tabs = TabControl1->Tabs;
   Caption = HlpCap;

   winpos = GetAppIni(HelpWinPos,"",AppQSdbc);
   if (!winpos.IsEmpty())
   {
      Left   = GetParam(0,winpos,",").ToIntDef(0); if (Left<0) Left = 0;
      Top    = GetParam(1,winpos,",").ToIntDef(0); if (Top<0) Top = 0;
      Width  = GetParam(2,winpos,",").ToIntDef(500);
      Height = GetParam(3,winpos,",").ToIntDef(300);
   }
}
//---------------------------------------------------------------------------
__fastcall THelpDlg::THelpDlg(TForm* Owner, AnsiString &Section, AnsiString &Title,
   AnsiString &ActiveTab) : TForm(Owner)
{
   owner = (TForm*)Owner;
   if (Owner) CenterDialog(this,owner);
   Tabs = TabControl1->Tabs;
   Caption = HlpCap+" "+Title;
   tabs = new TStringList();
   activetab = ActiveTab;
   section = Section;
   title = Title;

   winpos = GetAppIni(HelpWinPos,"",AppQSdbc);
   if (!winpos.IsEmpty())
   {
      Left   = GetParam(0,winpos,",").ToIntDef(0); if (Left<0) Left = 0;
      Top    = GetParam(1,winpos,",").ToIntDef(0); if (Top<0) Top = 0;
      Width  = GetParam(2,winpos,",").ToIntDef(500);
      Height = GetParam(3,winpos,",").ToIntDef(300);
   }

   RichEdit1->Clear();
   RichEdit1->BringToFront();
   RichEdit1->Align = alClient;
   HelpText->Align = alClient;

   Tabs->Clear();
   AnsiString sec,tab,key,title;
   TStringList *secs = new TStringList();
   TStringList *tmps = new TStringList(); tmps->Sorted = true;
   secs->Text = Section;
   for (int s=0; s<secs->Count; s++)
   {
      sec = secs->Strings[s];
      title = GetToken(1,sec,"_");
      key = GetToken(0,sec,"_")+PS+title;
      Tabs->AddObject(title,NULL);
      tabs->Add(key);
   }
//sm(key);
   /*for (int s=0; s<secs->Count; s++)
   {
      sec = secs->Strings[s];
      key = GetToken(0,sec,"_")+PS+GetToken(1,sec,"_");
      GetAppData(tmps,key,QSHelp());
      for (int i=0; i<tmps->Count; i++)
      {
         Tabs->AddObject(ChangeFileExt(tmps->Strings[i],""),NULL);
         tabs->Add(secs->Strings[s]+PS+ChangeFileExt(tmps->Strings[i],""));
      }
   }*/
   TopLine = new int[Tabs->Count];
   for (int i=0; i<Tabs->Count; i++)
      TopLine[i] = 0;
   int at = Tabs->IndexOf(ActiveTab); if (at<0) at=0;
   if (Tabs->Count)
   {
      TabControl1->TabIndex = at;
      LoadPage(at);
   }
   ActiveControl = Panel1;
   delete tmps;
   delete secs;
}
//---------------------------------------------------------------------------
__fastcall THelpDlg::THelpDlg(AnsiString &Section, AnsiString &Title,
   AnsiString &ActiveTab, TComponent* Owner) : TForm(Owner)
{
   //StayOnTop->Checked = GetAppIni(HelpStayOnTop,"").ToIntDef(1)==1;
   //FormStyle = StayOnTop->Checked ? fsStayOnTop : fsNormal;
   owner = (TForm*)Owner;

   if (Owner) CenterDialog(this,owner);
   Tabs = TabControl1->Tabs;
   Caption = HlpCap+" "+Title;
   tabs = new TStringList();
   activetab = ActiveTab;
   section = Section;
   title = Title;

   winpos = GetAppIni(HelpWinPos,"",AppQSdbc);
   if (!winpos.IsEmpty())
   {
      Left   = GetParam(0,winpos,",").ToIntDef(0); if (Left<0) Left = 0;
      Top    = GetParam(1,winpos,",").ToIntDef(0); if (Top<0) Top = 0;
      Width  = GetParam(2,winpos,",").ToIntDef(500);
      Height = GetParam(3,winpos,",").ToIntDef(300);
   }

   RichEdit1->Clear();
   RichEdit1->BringToFront();
   RichEdit1->Align = alClient;
   HelpText->Align = alClient;

   Tabs->Clear();
   AnsiString sec,tab;
   TStringList *secs = new TStringList();
   TStringList *tmps = new TStringList(); tmps->Sorted = true;
   secs->Text = Section;
   for (int s=0; s<secs->Count; s++)
   {
      GetAppData(tmps,secs->Strings[s],QSHelp());
      for (int i=0; i<tmps->Count; i++)
      {
         Tabs->AddObject(ChangeFileExt(tmps->Strings[i],""),NULL);
         tabs->Add(secs->Strings[s]+PS+ChangeFileExt(tmps->Strings[i],""));
      }
   }
   TopLine = new int[Tabs->Count];
   for (int i=0; i<Tabs->Count; i++)
      TopLine[i] = 0;
   int at = Tabs->IndexOf(ActiveTab); if (at<0) at=0;
   if (Tabs->Count)
   {
      TabControl1->TabIndex = at;
      LoadPage(at);
   }
   ActiveControl = Panel1;
   delete tmps;
   delete secs;
}
//---------------------------------------------------------------------------
__fastcall THelpDlg::THelpDlg(AnsiString &Topics, TComponent *Owner)
 : TForm(Owner)
{
   owner = (TForm*)Owner;

   if (Owner) CenterDialog(this,owner);
   Tabs = TabControl1->Tabs;
   Caption = HlpCap;
   tabs = new TStringList();

   winpos = GetAppIni(HelpWinPos,"",AppQSdbc);
   if (!winpos.IsEmpty())
   {
      Left   = GetParam(0,winpos,",").ToIntDef(0); if (Left<0) Left = 0;
      Top    = GetParam(1,winpos,",").ToIntDef(0); if (Top<0) Top = 0;
      Width  = GetParam(2,winpos,",").ToIntDef(500);
      Height = GetParam(3,winpos,",").ToIntDef(300);
   }

   RichEdit1->Clear();
   RichEdit1->BringToFront();
   RichEdit1->Align = alClient;
   HelpText->Align = alClient;

   Tabs->Clear();
   AnsiString top,sec,nam;
   TStringList *tops = new TStringList();
   TStringList *tmps = new TStringList(); tmps->Sorted = true;
   tops->Text = Topics;
   for (int t=0; t<tops->Count; t++)
   {
      top = tops->Strings[t];
      sec = top.SubString(1,top.Pos(", ")-1);
      int i=2; while (i<sec.Length())
         if (sec[i]==' ') sec.Delete(i,1);
         else i++;
      nam = top.SubString(top.Pos(", ")+2,256);
      if (!sec.IsEmpty() && !nam.IsEmpty())
      {
         Tabs->AddObject(top,NULL);
         tabs->Add(sec+PS+nam);
      }
   }
   TopLine = new int[Tabs->Count];
   for (int i=0; i<Tabs->Count; i++)
      TopLine[i] = 0;
   if (Tabs->Count)
   {
      TabControl1->TabIndex = 0;
      LoadPage(0);
   }
   ActiveControl = Panel1;
   delete tmps;
   delete tops;
}
//---------------------------------------------------------------------------
__fastcall THelpDlg::~THelpDlg()
{
   if (WindowState!=wsMaximized && WindowState!=wsMinimized)
   {
      winpos = s(Left)+","+s(Top)+","+s(Width)+","+s(Height);
      PutAppIni(HelpWinPos,winpos,AppQSdbc);
   }
   TMemoryStream *ms;
   for (int i=0; i<Tabs->Count; i++)
   {
      if ((ms=dynamic_cast<TMemoryStream*>(Tabs->Objects[i]))!=NULL)
         delete ms;
   }
   delete [] TopLine;
   delete tabs;
}
//---------------------------------------------------------------------------
void __fastcall THelpDlg::TabControl1Change(TObject *Sender)
{
   LoadPage(TabControl1->TabIndex);
   AppProcessMessages(); Sleep(100);
   RichEdit1->Visible = false;
}
//---------------------------------------------------------------------------
void __fastcall THelpDlg::TabControl1Changing(TObject *Sender, bool &AllowChange)
{
   RichEdit1->Visible = true; AppProcessMessages();
   TopLine[TabControl1->TabIndex] = HelpText->Perform(EM_GETFIRSTVISIBLELINE,0,0);
}
//---------------------------------------------------------------------------
void __fastcall THelpDlg::Print1Click(TObject *Sender)
{
   if (MsgBoxHwnd(Handle,"Print \""+Caption+"\" ?","Print",MB_OKCANCEL)==IDOK)
      HelpText->Print(Caption);
}
//---------------------------------------------------------------------------
void __fastcall THelpDlg::LoadPage(int Index)
{
   if (Index<0 || Index>=Tabs->Count) return;
   AnsiString name = Tabs->Strings[Index];
   TMemoryStream *ms = (TMemoryStream*)Tabs->Objects[Index];
   if (ms==NULL)
   {
      ms = new TMemoryStream();
      TStringList *txt = new TStringList();
      GetAppData(txt,tabs->Strings[Index]+".rtf",QSHelp());
      ms->Write(txt->Text.c_str(),txt->Text.Length());
      Tabs->Objects[Index] = ms;
      TopLine[Index] = 0;
      delete txt;
   }
   bool locked = LockWindowUpdate(Handle);
   ms->Seek(0,soFromBeginning);
   HelpText->Lines->LoadFromStream(ms);
   HelpText->Perform(EM_LINESCROLL,0,TopLine[Index]);
   Application->ProcessMessages();
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall THelpDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall THelpDlg::SetEditRect()
{
   TRect Rct = Rect(4,4,HelpText->ClientWidth-8,HelpText->ClientHeight-2);
   SendMessage(HelpText->Handle,EM_SETRECT,0,long(&Rct));
}
//---------------------------------------------------------------------------
void __fastcall THelpDlg::FormPaint(TObject *Sender)
{
   SetEditRect();
}
//---------------------------------------------------------------------------
void __fastcall THelpDlg::FormResize(TObject *Sender)
{
   SetEditRect();
}
//---------------------------------------------------------------------------
void __fastcall THelpDlg::FormShow(TObject *Sender)
{
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall THelpDlg::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   RichEdit1->Visible = false;
}
//---------------------------------------------------------------------------
void __fastcall THelpDlg::Close1Click(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
void __fastcall THelpDlg::Copy1Click(TObject *Sender)
{
   HelpText->CopyToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall THelpDlg::Edit1Click(TObject *Sender)
{
   Copy1->Enabled = HelpText->SelLength>0;
}
//---------------------------------------------------------------------------
void __fastcall THelpDlg::SelectAll1Click(TObject *Sender)
{
   HelpText->SelectAll();
}
//---------------------------------------------------------------------------
void __fastcall THelpDlg::StayOnTopClick(TObject *Sender)
{
   if (StayOnTop->Checked) StayOnTop->Checked = false;
   else StayOnTop->Checked = true;

   PutAppIni(HelpStayOnTop, StayOnTop->Checked ? "1":"0",AppQSdbc);
   MsgBoxHwnd(Handle,
      s("Stay on top is ")+(StayOnTop->Checked?"ON. ":"OFF. ")+
      s("Change will be in effect next time you open help."),
      s("Help Window"),
      MB_OK
   );
}
//---------------------------------------------------------------------------
