/*
*  NewsManDlgs2.cpp
*  Copyright  1999-2006 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "global.h"
#include "NewsManDlgs2.h"
#include "NewsProfDlgs2.h"
#include "fileman.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TNewsManDlg2 *NewsManDlg2;
//---------------------------------------------------------------------------

bool __fastcall RunNewsProfileManager2(TForm *Owner, TStrings *Accts, bool &getnewsnow)
{
   bool ok = false;
   NewsManDlg2 = new TNewsManDlg2(Owner, Accts);

   NewsManDlg2->ShowModal();
   if (NewsManDlg2->ModalResult == mrOk)
   {
      if (NewsManDlg2->modified)
      {
         Accts->Text = NewsManDlg2->AccountList->Items->Text;
         ok = true;
      }
      getnewsnow = NewsManDlg2->getnewsnow;
   }

   delete NewsManDlg2;
   return ok;
}
//---------------------------------------------------------------------------

bool __fastcall RunNewsProfileManagerNoGet2(TForm *Owner, TStrings *Accts)
{
   bool ok = false;
   NewsManDlg2 = new TNewsManDlg2(Owner, Accts);
   NewsManDlg2->allowget = false;

   NewsManDlg2->ShowModal();
   if (NewsManDlg2->ModalResult == mrOk)
   {
      if (NewsManDlg2->modified)
      {
         Accts->Text = NewsManDlg2->AccountList->Items->Text;
         ok = true;
      }
   }

   delete NewsManDlg2;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TNewsManDlg2::TNewsManDlg2(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

__fastcall TNewsManDlg2::TNewsManDlg2(TComponent* Owner, TStrings *Accts)
        : TForm(Owner)
{
   CenterDialog(this, Owner);
   AccountList->Items->AddStrings(Accts);
}
//---------------------------------------------------------------------------

__fastcall TNewsManDlg2::~TNewsManDlg2()
{
}
//---------------------------------------------------------------------------

void __fastcall TNewsManDlg2::NewBtnClick(TObject *Sender)
{
   AnsiString acct;
   if (NewAccountProfile2(this, acct, AccountList->Items))
   {
      AccountList->Items->Add(acct);
      modified = true;
   }
}
//---------------------------------------------------------------------------

void __fastcall TNewsManDlg2::EditBtnClick(TObject *Sender)
{
   int index = AccountList->ItemIndex;
   assert(index >= 0);

   AnsiString acct = AccountList->Items->Strings[index];
   if (NewAccountProfile2(this, acct, AccountList->Items))
   {
      AccountList->Items->Delete(index);
      AccountList->Items->Add(acct);
      modified = true;
   }
}
//---------------------------------------------------------------------------

void __fastcall TNewsManDlg2::DeleteBtnClick(TObject *Sender)
{
   int index = AccountList->ItemIndex;
   assert(index >= 0);

   if (ConfirmBox(this, "Delete the current account?    ", MB_OKCANCEL) == IDOK)
   {
      AccountList->Items->Delete(index);
      modified = true;
   }
}
//---------------------------------------------------------------------------

void __fastcall TNewsManDlg2::AccountListClick(TObject *Sender)
{
   bool hassel = AccountList->ItemIndex >= 0;
   DeleteBtn->Enabled = hassel;
   EditBtn->Enabled = hassel;
}
//---------------------------------------------------------------------------

void __fastcall TNewsManDlg2::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (modified)
   {
      if (ModalResult == mrCancel)
      {
         switch(ConfirmBox(this,
            "Your account list is modified. Save your changes?    ", MB_YESNOCANCEL))
         {
            case IDCANCEL: CanClose = false;
            case IDNO: return;
         }
      }
      PutAppData(NewsProfilesKey2, AccountList->Items, AppNewsIni);
   }
}
//---------------------------------------------------------------------------

void __fastcall TNewsManDlg2::AccountListDrawItem(TWinControl *Control,
        int Index, TRect &Rect, TOwnerDrawState State)
{
   TCanvas *Canvas = AccountList->Canvas;
   Canvas->FillRect(Rect);
   TStringList *item = new TStringList();
   item->CommaText = AccountList->Items->Strings[Index];

   AnsiString line = item->Values["login"];
   if (!line.IsEmpty())
      line += "@";
   line += item->Values["server"];
   Canvas->TextRect(Rect, Rect.Left + 3, Rect.Top + 2, line);
   delete item;
}
//---------------------------------------------------------------------------
