/*
*  QSNewsWins.cpp
*  Copyright  1999-2006 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "qsnewsver.h"
#include "QSNewsWins.h"
#include "NewsManDlgs2.h"
#include "NewsPasDlgs.h"
#include "NewsProfDlgs2.h"
#include "NewsTransDlgs.h"
#include "NewsNewDlgs.h"
#include "QSnewsVer.h"
#include "helpDlgs.h"
#include "Fileman.h"
#include "Headman.h"
#include "nymmail.h"
#include "Newsmail.h"
#include "newsubdlgs.h"
#include "headman.h"
//---------------------------------------------------------------------------
#pragma link "NntpCli"
#pragma link "explbtn"
#pragma resource "*.dfm"
TQSNewsWin *QSNewsWin;
bool SecureMode;
const AnsiString newsmanflag = "-manager";
const AnsiString newsgetflag = "-getnews";
const AnsiString mailgetflag = "-getmail";
const AnsiString newstrnflag = "-transfer";
const AnsiString newsunaflag = "-unattended";
const AnsiString NNTPProgress = "NNTP Progress";
const AnsiString LastMessageNumbers = "Message Numbers";
const AnsiString UserMailboxesInbox = UserMailboxes+PS+"Inbox";
//#define DISP(m) display->Add(m)
//---------------------------------------------------------------------------

bool __fastcall GetNextReplyBlock(TStrings *nym, TStrings *block, int &start, int &profile)
{
   assert(block != NULL);
   block->Clear();

   bool saving = false;
   while (start < nym->Count)
   {
      AnsiString line = nym->Strings[start].Trim();

      if (line.Pos("Sent:") == 1)
         break;

      if (line.Pos("Date:") == 1 || line.Pos("Retired:") == 1)
         profile++;

      if (line.Pos("Reply-Block:") == 1)
         saving = true;

      if (saving)
      {
         if (line.IsEmpty())
            break;

         block->Add(line);
      }

      start++;
   }

   return block->Count > 0;
}

//---------------------------------------------------------------------------

void __fastcall GetNymNewsgroupsSubjectsFromQS(TStrings *groups)
{
   assert(groups != NULL);
   groups->Clear();

   TStringList *nym = new TStringList();
   TStringList *nyms = new TStringList();
   TStringList *block = new TStringList();
   AnsiString file = AppDir + "QS.exe";

   GetAppData(nyms, "nyms2", AppMainDat);
   for (int i = 0; i < nyms->Count; i++)
   {
      AnsiString theNym = nyms->Strings[i];
      GetAppData(nym, "nyms2" + PS + theNym, AppMainDat);

      int start = 0, profile = 0;
      //for (int l = 0; l < nym->Count; l++)
      //{
      while (GetNextReplyBlock(nym, block, start, profile))
      {
         AnsiString newsgroup, subject, password;
         for (int b = block->Count - 2; b > 0; b--) // starting at the end of the block
         {                                               // and work up last leg
            AnsiString line = block->Strings[b].Trim();
            if (line.Pos(":") == 0) // start of a reply block leg
               break;        // we are only checking the last leg

            if (line.Pos("Newsgroups: ") == 1)
               newsgroup = line.SubString(13, 1024);

            else if (line.Pos("Anon-Post-To: ") == 1)
               newsgroup = line.SubString(15, 1024);

            else if (line.Pos("Subject: ") == 1)
               subject = line.SubString(10, 1024);

            else if (line.Pos("Encrypt-Subject: ") == 1)
               password = line.SubString(18, 1024);
         }

         if (!newsgroup.IsEmpty())
         {
            groups->Add(newsgroup + "\255" + subject + "\255" + password); // + "\255" + GetToken(0, theNym, "\255"));
         }
      }
   }

   delete block;
   delete nyms;
   delete nym;
}
//---------------------------------------------------------------------------

/*void __fastcall GetNymNewsgroupsSubjectsFromQS(TStrings *groups)
{
   assert(groups != NULL);
   groups->Clear();

   TStringList *nym = new TStringList();
   TStringList *nyms = new TStringList();
   TStringList *block = new TStringList();
   AnsiString file = AppDir + "QS.exe";

   GetAppData(nyms, "nyms2", AppMainDat);
   for (int i = 0; i < nyms->Count; i++)
   {
      AnsiString theNym = nyms->Strings[i];
      GetAppData(nym, "nyms2" + PS + theNym, AppMainDat);
view(nym);
      int start = 0, profile = 0;

      for (int l = 0; l < nym->Count; l++)
      {
         if (!GetNextReplyBlock(nym, block, start, profile))
            break;

         AnsiString newsgroup, subject, password;
         for (int b = block->Count - 2; b > 0; b--) // starting at the end of the block
         {                                               // and work up last leg
            AnsiString line = block->Strings[b].Trim();
            if (line.Pos(":") == 0) // start of a reply block leg
               break;        // we are only checking the last leg

            if (line.Pos("Newsgroups: ") == 1)
               newsgroup = line.SubString(13, 1024);

            else if (line.Pos("Anon-Post-To: ") == 1)
               newsgroup = line.SubString(15, 1024);

            else if (line.Pos("Subject: ") == 1)
               subject = line.SubString(10, 1024);

            else if (line.Pos("Encrypt-Subject: ") == 1)
               password = line.SubString(18, 1024);
         }

         if (!newsgroup.IsEmpty())
         {
            groups->Add(newsgroup + "\255" + subject + "\255" + password); // + "\255" + GetToken(0, theNym, "\255"));
         }
      }
   }

   delete block;
   delete nyms;
   delete nym;
}*/
//---------------------------------------------------------------------------

__fastcall TQSNntpCli::TQSNntpCli(TComponent *Owner)
   : TNntpCli(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TQSNntpCli::WSocketDnsLookupDone(TObject *Sender, WORD Error)
{
   if (Error != 0)
      TriggerRequestDone(nntpAbort, Error);
   else
   {
      FWSocket->Addr = FWSocket->DnsResult;
      FWSocket->Proto = "tcp";
      StateChange(nntpWaitingBanner);
      FWSocket->Connect();
   }
}

//---------------------------------------------------------------------------

bool __fastcall HasEsub()
{
   return hEsubLib!=NULL;
}
//---------------------------------------------------------------------------

bool __fastcall NeedsEsub(TStrings *profiles)
{
   bool needesub=false;
   for (int i = 0; i < profiles->Count; i++)
   {
      AnsiString profile = profiles->Strings[i];
      if (!GetToken(2, profile, "\255").IsEmpty())
      {
         needesub = true;
         break;
      }
   }
   return needesub;
}
//---------------------------------------------------------------------------

__fastcall TQSNewsWin::TQSNewsWin(TComponent* Owner)
	: TForm(Owner)
{
    // write the version to the ini for QS 'About' check
    if (ParamCount()>0 && ParamStr(1)=="-version")
    {
       PutAppIni("version",ReleaseVer,AppIni);
       Application->ShowMainForm = false;
       PostMessage(Handle,WM_QUIT,0,0);
       return;
    }

    Caption = Caption+" "+ReleaseVer;
    cap = Caption;
   // if AppNewsDat exists copy it to AppMainDat
   if (FileExists(AppNewsDat) && FileExists(AppMainDat))
   {
      HandleNewsgroupMail(NULL);
      if (ParamCount()>0 && ParamStr(1)==newstrnflag)
      {
         Application->ShowMainForm = false;
         PostMessage(Handle,WM_QUIT,0,0);
      }
   }

   // begin initialization
   dogetnews = false;
   unattended = false;
   SecureMode = !FileExists(AppMainDat);// && FileExists(AppMainPgp);
   if (SecureMode && !FileExists(AppNewsIni))
   {
      MsgDlg(NULL,
         "I see your QS database is encrypted. Also, your 'QSnews.ini' file is missing.\n"
         "It contains the basic server/newsgroup info necessary to retrieve your mail\n"
         "when QS is not open.\n\n"
         "It can be recreated by:\n"
         "1) open QS\n"
         "2) open QSnews\n"
         "3) modify the server or newsgroup info\n"
         "4) close QSnews.",
         "Fatal Error",
          MB_OK);
      Application->ShowMainForm = false;
      PostMessage(Handle, WM_QUIT, 0, 0);
      return;
   }

   if (GetAppIni("firstrun", "1", AppNewsIni) == "1" && SecureMode)
   {
      InfoBox(this,
         "If you have news accounts defined, please open QS now and decrypt    \n"
         "decrypt the database so I can copy the info to QSnews. Click Ok    \n"
         "when you are done.", MB_OK);
   }
   PutAppIni("firstrun", "0", AppNewsIni);

   // initialize window position
   AnsiString windowstate = GetAppIni("WindowState","",AppIni);
   TWindowState winstate = (TWindowState)GetToken(0,windowstate," ").ToIntDef(wsNormal);
   winpos = GetToken(1,windowstate," ");
   Color = (TColor)GetToken(2,windowstate," ").ToIntDef(clTeal);
   if (windowstate.IsEmpty()) Color = (TColor)GetAppIni(WorkSpaceColor,"", AppIni).ToIntDef(clTeal);
   if (winpos.IsEmpty())
   {
      winstate = (TWindowState)GetAppIni("WinState","",AppIni).ToIntDef(0);
      winpos = GetAppIni("WinPosition","",AppIni);
   }
   // initialize window position
   int h = 354;
   int w = 516;
   int x = (Screen->Width-w)/2;
   int y = (Screen->Height-h)/2;
   if (winpos.IsEmpty())
      winpos = IntToStr(x) + "," + IntToStr(y) + "," + IntToStr(w) + "," + IntToStr(h);
   Left   = GetParam(0,winpos,",").ToIntDef(x);
   Top    = GetParam(1,winpos,",").ToIntDef(y);
   Width  = GetParam(2,winpos,",").ToIntDef(w);
   Height = GetParam(3,winpos,",").ToIntDef(h);

   // adjust position to screen if something is out of wak
   if (Height > Screen->Height) Height = Screen->Height;
   if (Width > Screen->Width) Width = Screen->Width;
   if (Left+Width > Screen->Width) Left = Screen->Width-Width;
   if (Top+Height > Screen->Height-28) Top = Screen->Height-28-Height;
   if (Left < -1) Left = -1;
   if (Top < -1) Top = -1;

   WindowState = winstate;
   DisplayMemo->Clear();
   display = DisplayMemo->Lines;
   hEsubLib = LoadLibrary("psesub32.dll");

   GetAppData(ServerBox->Items, NewsProfilesKey2, AppNewsIni);
   if (ServerBox->Items->Count > 0)
   {
      bool needsave = false;
      ServerBox->Sorted = false;
      TStringList *item = new TStringList();
      for (int i = 0; i < ServerBox->Items->Count; i++)
      {
         item->CommaText = ServerBox->Items->Strings[i];
         if (item->Values["sort"].IsEmpty())
         {
            AnsiString acct, login, server;
            login = item->Values["login"];
            server = item->Values["server"];
            acct = login;
            if (!acct.IsEmpty())
               acct += "@";
            acct += server;
            item->Insert(0, "sort=" + acct);
            ServerBox->Items->Strings[i] = item->CommaText;
            needsave = true;
         }
      }
      delete item;
      ServerBox->Sorted = true;
      if (needsave)
      {
         PutAppData(NewsProfilesKey2, ServerBox->Items, AppNewsIni);
      }
   }

   // convert old profiles
   if (ServerBox->Items->Count == 0 && !SecureMode)
   {
      AnsiString server, login, password, remember, newsgroup, newsgroups;
      TStringList *item = new TStringList();
      TStringList *groups = new TStringList();
      TStringList *oldprofiles = new TStringList();
      TStringList *newprofiles = new TStringList();
      GetAppData(oldprofiles, NewsProfilesKey, AppMainDat);
      TrimNulls(oldprofiles);

      if (oldprofiles->Count > 0)
      {
         oldprofiles->Add(""); // insures a trainling null line
         for (int i = 0; i < oldprofiles->Count; i++)
         {
            AnsiString line = oldprofiles->Strings[i].Trim();
            if (line.Pos("server=") == 1)
            {
               server = line.SubString(8, 64);
               int p = server.Pos("@");
               if (p > 0)
                  server = server.SubString(p + 1, 1024);
               continue;
            }
            if (line.Pos("login=") == 1)
            {
               login = line.SubString(7, 64);
               continue;
            }
            if (line.Pos("password=") == 1)
            {
               password = line.SubString(10, 64);
               continue;
            }
            //if (line.Pos("remember=") == 1)
            //{
            //   remember = line.SubString(10, 64);
            //   continue;
            //}
            if (line.Pos("newsgroup=") == 1)
            {
               newsgroup = line.SubString(11, 256);
               continue;
            }
            if (line.Pos("lastmessage=") == 1)
            {
               groups->Values[newsgroup] = line.SubString(13, 32);
               continue;
            }
            if (line.IsEmpty())
            {
               item->Clear();
               item->Values["sort"] = login + "@" + server;
               item->Values["server"] = server;
               item->Values["login"] = login;
               item->Values["password"] = password;
               item->Values["remember"] = remember;
               item->Values["newsgroups"] = groups->CommaText;
               newprofiles->Add(item->CommaText);

               server = "";
               login = "";
               password = "";
               remember = "";
               newsgroup = "";
               groups->Clear();
               item->Clear();
            }
         }
         delete groups;

         PutAppData(NewsProfilesKey2, newprofiles, AppNewsIni);
         ServerBox->Items->AddStrings(newprofiles);
      }
      delete newprofiles;
      delete oldprofiles;
      delete item;
   }

   if (ServerBox->Items->Count > 0)
   {
      AnsiString last, first = ServerBox->Items->Strings[0];
      last = GetAppIni("lastaccount", "", AppNewsIni);
      ServerBox->ItemIndex = ServerBox->Items->IndexOf(last);
      if (ServerBox->ItemIndex < 0)
         ServerBox->ItemIndex = 0;
   }

   ServerBtn->Enabled = ServerBox->ItemIndex >= 0;

   if (!HasEsub() && NeedsEsub(ServerBox->Items))
   {
      MsgDlg(NULL,
         "I have a problem. The file 'psesub32.dll' is not in the QS home directory.\n"
         "It provides 'encrypt-subject' services for the QSnews Plugin. I've looked\n"
         "at your new account profiles and you do make use of the esub feature.\n\n"
         "You can most easily fix the problem by:\n"
         "1) close QSnews\n"
         "2) open QS\n"
         "3) open the Update Wizard\n"
         "4) get the latest update for QSnews.\n\n"
         "It won't matter if it is the same version you have.",
         "File PSESUB32.DLL Missing",
          MB_OK);
      Application->ShowMainForm = false;
      PostMessage(Handle,WM_QUIT,0,0);
      return;
   }

   working = false;
   closing = false;
   PutAppIni("version",ReleaseVer,AppIni);

   article = new TMemoryStream();
   subjects = new TStringList();
   message = new TStringList();
   InSubject = false;
   InBody = false;
   InHead = false;
   mails = 0;
   lastmessagenum = new TStringList();
   estimated = curmessage = curgroup = -1; //curprofile = -1;
   openaccounts = false;

   if (ParamCount())
   {
      int i = 0; while(++i <= ParamCount())
      {
         AnsiString paramstr = ParamStr(i);

         if (paramstr == newsmanflag)
         {
            openaccounts = true;
         }

         if (paramstr == newsgetflag || paramstr == mailgetflag)
         {
            dogetnews = true;
            Caption = NNTPProgress;
            GetBtn->Enabled = false;
            CancelBtn->Enabled = true;
            ActiveControl = DisplayMemo;
            DisplayMemo->Clear();
            continue;
         }

         if (paramstr==newsunaflag)
         {
            unattended = true;
         }
      }
   }

   Application->OnHint = ShowHint;

   NNTP = new TQSNntpCli(this);
   NNTP->OnDisplay = NNTPDisplay;
   NNTP->OnMessageBegin = NNTPMessageBegin;
   NNTP->OnMessageEnd = NNTPMessageEnd;
   NNTP->OnMessageLine = NNTPMessageLine;
   NNTP->OnRequestDone = NNTPRequestDone;
   NNTP->OnSessionClosed = NNTPSessionClosed;
   NNTP->OnSessionConnected = NNTPSessionConnected;
   NNTP->OnXHdrLine = NNTPXHdrLine;

   proxy = new TStringList();
   if (!SecureMode)
   {
      AnsiString proxyname = GetAppIni("newsproxy", "<none>", AppIni);
      if (proxyname != "<none>")
      {
         TStringList *proxies = new TStringList();
         GetAppData(proxies, "proxies", AppMainDat);

         if (proxies->IndexOf(proxyname) < 0)
         {
            MsgBoxHwnd(this,
               "The socks proxy you have been using '" + GetToken(0, proxyname, ",") + "', has been deleted!\n"
               "You'll need to set your proxy again before continuing.",
               "Warning", MB_OK);
            dogetnews = false;
         }

         delete proxies;
      }

      TStringList *subs = new TStringList();
      subs->Sorted = true;
      GetNymNewsgroupsSubjectsFromQS(subs);
      PutAppData("nymdata", subs, AppNewsIni);
      delete subs;
   }

   ResetBtn->Top = GetBtn->Top;
   ResetBtn->Hide();
   DisplayMemo->Align = alClient;
   SubList->Align = alClient;
   DisplayMemo->Hide();
   SubList->Show();

   newsgroups = new TStringList();
   groupsubjects = new TStringList();

   subs = new TStringList();
   subs->Duplicates = dupIgnore;
   subs->Sorted = true;

   usubs = new TStringList();
   usubs->Duplicates = dupIgnore;
   usubs->Sorted = true;

   LoadSubList();

   DownloadAll->Checked = (bool)GetAppIni("downloadall", "1", AppNewsIni).ToIntDef(1);
   LoadProxyBox();

   InMessage = false;

   if (dogetnews)
      Timer1->Enabled = true;

}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::LoadSubList()
{
   SubList->Items->Clear();

   AnsiString newsgroup;
   TStringList *groups = new TStringList();

   GetAppData(subs, "nymdata", AppNewsIni);
   GetAppData(usubs, "userdata", AppNewsIni);
   subs->AddStrings(usubs);

   for (int i = 0; i < subs->Count; i++)
   {
      AnsiString group, line = subs->Strings[i];
      group = GetToken(0, line, "\255");
      if (group != newsgroup)
      {
         SubList->Items->AddObject(group, (TObject*)1);
         groups->Add(group);
         newsgroup = group;
      }

      SubList->Items->AddObject(subs->Strings[i], (TObject*)1);
   }

   GetAppData(subs, "nymdata", AppNewsIni); // reload subs to get rid of usubs

   LoadTick();

   delete groups;
}
//---------------------------------------------------------------------------

__fastcall TQSNewsWin::~TQSNewsWin()
{
   delete usubs;
   delete subs;
   delete groupsubjects;
   delete newsgroups;
   delete proxy;
   delete NNTP;
   if (hEsubLib) FreeLibrary(hEsubLib);
   delete lastmessagenum;
   delete message;
   delete subjects;
   delete article;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::ShowHint(TObject *Sender)
{
   StatusBar1->SimpleText = Application->Hint;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::Exit1Click(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::OpenNewsItemClick(TObject *Sender)
{
   int index = ServerBox->ItemIndex;
   TStringList *profiles = new TStringList();
   profiles->AddStrings(ServerBox->Items);
   if (RunNewsProfileManagerNoGet2(this, profiles))
   {
      ServerBox->Clear();
      ServerBox->Items->AddStrings(profiles);
      ServerBox->ItemIndex = index;
   }
   delete profiles;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   if (dogetnews)
      GetBtn->Click();
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::GetMailBtnClick(TObject *Sender)
{
   DisplayMemo->Clear();
   DisplayMemo->Show();
   SubList->Hide();
   Caption = "NNTP Progress";
   Sleep(300);

   GetBtn->Enabled = false;
   CancelBtn->Enabled = true;

   ActiveControl = DisplayMemo;
   display->Clear();
   mails = 0;
   GetTheMail();
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::CancelBtnClick(TObject *Sender)
{
   cancel = true;
   if (!connected)
      SetLastLine("USER Cancelled Operation!");
   NNTP->Abort();

   if (mails == 1) display->Add("1 new message");
   else if (mails > 1) display->Add(IntToStr(mails)+" new messages");

   GetBtn->Show();
   CancelBtn->Enabled = false;
   ProgressBar->Visible = false;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (working)
   {
      CancelBtn->Click();
      CanClose = false;
      return;
   }
   if (WindowState != wsMaximized)
      winpos = IntToStr(Left) + "," + IntToStr(Top) + "," + IntToStr(Width) + "," + IntToStr(Height);
   PutAppIni("WindowState", IntToStr(WindowState) + " " + winpos + " " + IntToStr(Color), AppIni);

   SaveTick();
   ServerBoxChange(NULL);
   closing = true;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::SetEditRect()
{
   TRect Rct = Rect(3,0,DisplayMemo->ClientWidth-4,ClientHeight);
   DisplayMemo->Perform(EM_SETRECT,0,long(&Rct));
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::FormResize(TObject *Sender)
{
   SetEditRect();
   ProgressBar->Top = StatusBar1->Top + 2;
   ProgressBar->Width = StatusBar1->Width - 1;

   static int lastW = 1024000;
   if ((lastW < Panel1->Width && Panel1->Width > 530) || ServerBtn->Left > 200)
   {
      ProxyBox->Left = Panel1->Width - 90;
      Label2->Left = ProxyBox->Left - 42;
      ServerBox->Left = Label2->Left - 176;
      ServerBtn->Left = ServerBox->Left - 26;
      DownloadAll->Left = ServerBtn->Left - 90;
   }
   lastW = Panel1->Width;
}
//---------------------------------------------------------------------------

AnsiString __fastcall SocksVer4Sure(const AnsiString &socksver)
{
   AnsiString ver = "4";
   if (socksver == "4a" ||  socksver == "5")
      ver = socksver;
   return ver;
}
//---------------------------------------------------------------------------

bool __fastcall TQSNewsWin::GetTheMail()
{
   while (connected)
      AppProcessMessages();

   NNTP = new TQSNntpCli(this);
   NNTP->OnDisplay = NNTPDisplay;
   NNTP->OnMessageBegin = NNTPMessageBegin;
   NNTP->OnMessageEnd = NNTPMessageEnd;
   NNTP->OnMessageLine = NNTPMessageLine;
   NNTP->OnRequestDone = NNTPRequestDone;
   NNTP->OnSessionClosed = NNTPSessionClosed;
   NNTP->OnSessionConnected = NNTPSessionConnected;
   NNTP->OnXHdrLine = NNTPXHdrLine;

   bool remember;
   working = true; cancel = false;
   GetNewsgroups(newsgroups);

   NNTP->Host = GetToken(0, ProfileServer(), ":");
   NNTP->CtrlSocket->Port = GetToken(1, ProfileServer(), ":", "119");

   NNTP->UserName = ProfileUserID();
   NNTP->PassWord = ProfilePassword();

   if (!NNTP->UserName.IsEmpty() && NNTP->PassWord.IsEmpty())
   {
      NNTP->PassWord = GetAccountPassword(this, SecureMode, remember);
      if (remember && !NNTP->PassWord.IsEmpty())
      {
         SetProfilePassword(NNTP->PassWord);
         SaveProfiles();
      }
   }

   NNTP->CtrlSocket->SocksServer = "";
   NNTP->CtrlSocket->SocksPort = "";
   NNTP->CtrlSocket->SocksLevel = "4";
   NNTP->CtrlSocket->SocksUsercode = "";
   NNTP->CtrlSocket->SocksPassword = "";
   NNTP->CtrlSocket->SocksAuthentication = socksNoAuthentication;

   AnsiString proxyname = GetAppIni("lastproxy", "<none>", AppIni);
   if (proxyname != "<none>")
   {
      GetAppData(proxy, "newsproxy", AppIni);

      AnsiString sockshost, socksport;
      sockshost = proxy->Values["host"],
      socksport = proxy->Values["nntpport"];

      if (!sockshost.IsEmpty() && !socksport.IsEmpty())
      {
         NNTP->CtrlSocket->SocksServer = sockshost;
         NNTP->CtrlSocket->SocksPort = socksport;
         NNTP->CtrlSocket->SocksLevel = SocksVer4Sure(proxy->Values["socksver"]);

         if (proxy->Values["auth"] == "1")
         {
            NNTP->CtrlSocket->SocksUsercode = proxy->Values["userid"];
            NNTP->CtrlSocket->SocksPassword = proxy->Values["password"];
            NNTP->CtrlSocket->SocksAuthentication = socksAuthenticateUsercode;
         }
      }
   }

   display->Add("Proxy: " + GetToken(0, proxyname, ","));
   display->Add("Connecting to " + ProfileServer() + "... ");

   curgroup = -1;
   //if (SecureMode || DownloadAll->Checked)
   //{
   //   NNTP->OnRequestDone = NNTPRequestDoneAll;
   //}
   //else
   //{
   //   NNTP->OnRequestDone = NNTPRequestDone;
   //}

   NNTP->Connect();
   return true;
}
//---------------------------------------------------------------------------

AnsiString __fastcall DropCrLf(AnsiString line)
{
   int L = line.Length();
   if (line.Pos("\r\n")>L-2) line = line.SubString(1,L-2);
   return line;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::NNTPDisplay(TObject *Sender, void *Msg, int Len)
{
   if (!InHead && !InBody && !InSubject)
   {
      AnsiString msg = DropCrLf((char*)Msg);
      if (msg.Pos("223 ")==1) msg = " "+GetToken(1,msg," ");
      if (msg.Pos("421 ")==1 || msg.Pos("211 ")==1) return;
      if (msg.Pos("205 .")==1) return;
      if (msg.Pos("423 ")==1) return;
      display->Add(" "+msg);
   }
}
//---------------------------------------------------------------------------

void __fastcall ParseResponse(AnsiString Response, AnsiString &Newsgroup, int &MsgEstimate,
   int &FirstMessage, int &LastMessage, char &PostFlag)
{
   AnsiString token;
   int toc=0; while((token=GetToken(toc,Response," ").Trim())!="")
   {
      switch (toc)
      {
         case 1: MsgEstimate =  token.ToIntDef(-1); break;
         case 2: FirstMessage = token.ToIntDef(-1); break;
         case 3: LastMessage =  token.ToIntDef(-1); break;
         case 4: Newsgroup = token; break;
      }
      toc++;
   }
}
//---------------------------------------------------------------------------

int __fastcall TQSNewsWin::GetNextArticleNumber()
{
   return GetToken(1,NNTP->LastResponse," ").ToIntDef(-1);
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::SetLastArticle(AnsiString &disposed)
{
   AnsiString msg = display->Strings[display->Count-1];
   display->Strings[display->Count-1] = msg + disposed;
}
//---------------------------------------------------------------------------

int __fastcall TQSNewsWin::GetNewsgroupStartMessageNum()
{
   AnsiString name; char flag;
   int pick=-1, firstavail, esti,
      thelast = ProfileNewsgroupLastArticleNum(curNewsgroup);
   ParseResponse(NNTP->LastResponse, name, esti, firstavail, lastavail, flag);
   estimated=esti;

   if (thelast <= 0 || thelast > lastavail + 1)
   {
      if ((pick = GetNewNewsgroupDownloadCount(this, name, estimated)) < 0)
      {
         display->Add(" Operation cancelled!");
         cancel = true;
         NNTP->Quit();
         return pick;
      }

      pick = lastavail - (pick - 1);
      if (pick < firstavail)
         pick = firstavail;
   }

   if (!pick && thelast < firstavail)
      thelast = firstavail;

   lastread = pick>0 ? pick : thelast;
   display->Add(" 211 " + IntToStr(lastavail - (lastread - 1)) + " " + IntToStr(lastread - 1)+" "+
      IntToStr(lastavail) + " " + name + AnsiString(DownloadAll->Checked ? " /all" : ""));

   return lastread;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TQSNewsWin::NewsServerCount()
{
   int curr = curmsg - (lastread - 1), final = lastavail - (lastread - 1);
   return IntToStr(curr) + " of " + IntToStr(final < curr ? curr : final) + " (" + IntToStr(mails) + ")";
}
//---------------------------------------------------------------------------

AnsiString __fastcall TQSNewsWin::NewsServerNameCaption()
{
   return "USENET HOST:  " + ProfileName();
}
//---------------------------------------------------------------------------

AnsiString __fastcall TQSNewsWin::NewsServerNameAndCountCaption()
{
   return "NNTP Progress  " + NewsServerCount();
}
//---------------------------------------------------------------------------

AnsiString __fastcall GetCurmsgAndSubject(int &curmsg, AnsiString subject)
{
   curmsg = GetToken(0, subject, " ").ToIntDef(-1);
   return "Subject: " + subject.SubString(subject.Pos(" ") + 1, 256);
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::NNTPRequestDone(TObject *Sender, TNntpRequest RqType,
	WORD Error)
{
   int last;
   AnsiString name,msg,subject;
   if (!working)
      return;

   if (Error && Error != 421 && Error != 423 && Error != 400 && Error != 411)
   {
      AnsiString errmsg = NNTP->ErrorMessage;
      if (errmsg.IsEmpty())
         errmsg = WSocketErrorDesc(Error);

      display->Add("Error: " + IntToStr(Error) + " " + errmsg);
      display->Add("Aborting...");
      CancelBtn->Enabled = false;
      GetBtn->Enabled = true;
      working = false;
      cancel = true;
      Caption = cap;
      NNTP->Abort();
      return;
   }

   switch(RqType)
   {
      case nntpConnect:
      case nntpAuthenticate: // nntp->authenticate done in SessionConnected below
         while (NNTP->State != nntpReady && !Application->Terminated)
            Application->ProcessMessages();

         if (closing)
            return;

         curgroup++;
         if (curgroup >= newsgroups->Count)
         {
            NNTP->Quit();
            return;
         }

         curNewsgroup = newsgroups->Strings[curgroup];
         GetNewsgroupSubjects(curNewsgroup, groupsubjects);
         NNTP->Group(curNewsgroup);
         return;

      case nntpGroup:
         while (NNTP->State != nntpReady && !Application->Terminated)
            Application->ProcessMessages();

         if (curgroup >= newsgroups->Count)
            return;

         if (NNTP->StatusCode != 211 && NNTP->StatusCode != 411)
         {
            display->Add("Aborting...");
            NNTP->Abort();
            return;
         }

         if (NNTP->StatusCode == 411) // no such group
         {
            NNTPRequestDone(this, nntpConnect, 0);
            return;
         }

         estimated = -1;
         if ((curmsg = GetNewsgroupStartMessageNum()) > lastavail || curmsg == -1)
         {
            NNTPRequestDone(this, nntpConnect, 0);
            return;
         }

         cursub = -1;
         display->Add(" Retrieving headers...");
         ProgressBar->Position = 0;
         ProgressBar->Visible = true;
         subjects->Clear();
         msg = "";
         InSubject = true;
         NNTP->XHdr(NULL, "subject", IntToStr(curmsg) + "-");
         return;

      case nntpXHdr:
         while (NNTP->State != nntpReady && !Application->Terminated)
            Application->ProcessMessages();

         if (InSubject)
         {
            int c = lastavail - (lastread - 1);

            if (c == 1) msg = " Scanning 1 new header";
            else if (c > 1) msg = " Scanning " + IntToStr(c) + " new headers";

            //DisplayMemo->Lines->Strings[DisplayMemo->Lines->Count-1] = msg;
            DisplayMemo->Lines->Add(msg);
         }

         InSubject = false;
         AppProcessMessages();

         while (++cursub < subjects->Count)
         {
            message->Text = GetCurmsgAndSubject(curmsg, subjects->Strings[cursub]);
            if (!cancel)
            {
               Caption = " Scanning " + NewsServerCount();
               Application->ProcessMessages();
               SetProfileNewsgroupLastArticleNum(curNewsgroup, curmsg);
               if (SecureMode || DownloadAll->Checked || IsNewsgroupSubjectMatch(curNewsgroup, message))
               {
                  while (NNTP->State != nntpReady && !Application->Terminated)
                     Application->ProcessMessages();

                  InHead = true;

                  //Caption = cap + " -- HeadByNumber";
                  NNTP->HeadByNumber(curmsg, NULL);
                  return;
               }
            }
         }

         NNTPRequestDone(this, nntpConnect, 0);
         return;

      case nntpHeadByNumber:
         while (NNTP->State != nntpReady && !Application->Terminated)
            Application->ProcessMessages();

         InHead = false;

         Application->ProcessMessages();
         if (!cancel && NNTP->StatusCode==221)
         {
            InBody = true;
            ProgressBar->Position = 0;
            ProgressBar->Visible = true;
            Application->Title = "QSnews "+NewsServerCount();
            display->Add(" Retrieving message " + IntToStr(curmsg) + " (" + NewsServerCount() + ")");
            DisplayMemo->Perform(EM_SCROLLCARET, 0, 0);

            //Caption = cap + " -- BodyByNumber";
            NNTP->BodyByNumber(curmsg, NULL);
            return;
         }

         last = ProfileNewsgroupLastArticleNum(curNewsgroup);
         SetProfileNewsgroupLastArticleNum(curNewsgroup, last-1);
         NNTPRequestDone(this, nntpConnect, 0);
         return;

      case nntpBodyByNumber:
         while (NNTP->State != nntpReady && !Application->Terminated)
            Application->ProcessMessages();

         InBody = false;
         display->Strings[display->Count - 1] = " Retrieving message " + IntToStr(curmsg) + " (" + NewsServerCount() + ")"; //+ NewsServerCount();
         AppProcessMessages();

         Application->ProcessMessages();
         if (!cancel)
         {
            NNTPRequestDone(this, nntpXHdr, 0);
            return;
         }

         last = ProfileNewsgroupLastArticleNum(curNewsgroup);
         SetProfileNewsgroupLastArticleNum(curNewsgroup, last-1);
         NNTPRequestDone(this, nntpConnect, 0);
         return;

      case nntpQuit:
      case nntpAbort:
         working = false;

         while (NNTP->State != nntpReady && !Application->Terminated)
            Application->ProcessMessages();

         Application->Title = "QSnews Done! (" + IntToStr(mails) + ")";
         ProgressBar->Visible = false;
         Caption = cap;

         if (RqType == nntpAbort)
         {
            if (display->IndexOf("Connection closed!") >= 0)
               display->Add("Done");
            return;
         }
   }
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::NNTPSessionConnected(TObject *Sender, WORD Error)
{
   connected = true;
   if (!NNTP->UserName.IsEmpty())
   {
      NNTP->Authenticate();
      return;
   }
   NNTPRequestDone(NULL,nntpConnect,0);
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::SetLastLine(AnsiString msg)
{
   if (display->Count && display->Strings[display->Count-1]!=msg)
       display->Add(msg);
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::NNTPSessionClosed(TObject *Sender, WORD Error)
{
   if (cancel) SetLastLine("USER Cancelled Operation!");
   SetLastLine("Connection closed!");

   if (!mails)
      display->Add("No mail");
   else
   {
      display->Add(s(mails)+s(" new message")+(mails>1?"s":""));
      if (!SecureMode && (hWndQS=FindWindow("TQSMainWin",NULL))!=NULL && IsWindowVisible(hWndQS))
      {
        SendMessage(hWndQS,WM_OPENINBOX,0,NULL);
        Snooze(200);
        Close();
        return;
      }
   }

   CancelBtn->Enabled = false;
 //AccountsBtn->Enabled = true;
 //ResetBtn->Show();
   GetBtn->Enabled = true;
 //GetBtn->Hide();
   connected = false;

   if (unattended)
   {
      Close();
   }

   Caption = cap;
}
//---------------------------------------------------------------------------

bool __fastcall TQSNewsWin::SaveMessageViaQS(HWND hWndQS, TStrings *Message)
{
   int length = message->Text.Length()+1;
   char *msg = new char[length];
   strcpy(msg,message->Text.c_str());
   COPYDATASTRUCT copydata;
   copydata.dwData = WM_INCOMINGMAIL;
   copydata.cbData = length;
   copydata.lpData = msg; // try copydata, if fail putappdata
   if (SendMessage(hWndQS,WM_COPYDATA,(UINT)Handle,(LPARAM)&copydata)==6666)
      return true;
   return false;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::SaveMessage(TStrings *Message)
{
   PutAppData(UserMailboxesInbox+PS+InIndexString(Message),Message,
      SecureMode?AppNewsDat:AppMainDat);
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::NNTPMessageBegin(TObject *Sender)
{
   if (InHead)
   {
      message->Clear();
      curline = 0;
   }
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::NNTPMessageEnd(TObject *Sender)
{
   if (cancel)
      return;

   if (InSubject)
   {
      ProgressBar->Position = 100; Snooze(100);
      ProgressBar->Visible = false;
      return;
   }

   if (curline==bodlines)
   {
      ProgressBar->Position = 100;
      Snooze(20);
   }

   if (InHead)
   {
      if (message->Count)
      {
          THeaderManager *hm = new THeaderManager(message);
          bodlines = hm->GetDat("Lines: ").ToIntDef(-1);
          if (bodlines == 0)
             bodlines = -1;
             
          //DisplayMemo->Lines->Add("");
          //DisplayMemo->Lines->AddStrings(message);
          //DisplayMemo->Lines->Add(IntToStr(curmsg)+": " + IntToStr(bodlines));
          //DisplayMemo->Lines->Add("");

          ProgressBar->Position = 0;
          delete hm;
      }
      message->Add("");
   }

   if (InBody)
   {
      TrimNulls(message);
      Snooze(100); ProgressBar->Position = 0;
      if (SecureMode)
      {
         message->Insert(0, ProfileName() + "|" + curNewsgroup + "|" + IntToStr(curmsg));
         SaveMessage(message);
         mails++;
      }
      else
      {
         if (IsNewsgroupSubjectMatch(curNewsgroup, message))
         {
            SaveMessage(message);
            mails++;
         }
      }

      SetProfileNewsgroupLastArticleNum(curNewsgroup, curmsg);
   }
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::NNTPXHdrLine(TObject *Sender)
{
   ProgressBar->Position = cursub / estimated * 100;
   subjects->Add(NNTP->LastResponse);
   return;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::NNTPMessageLine(TObject *Sender)
{
   if (InHead)
   {
      message->Add(NNTP->LastResponse);
      //DisplayMemo->Lines->Add("   " + NNTP->LastResponse);
      return;
   }

   if (InBody)
   {
      ProgressBar->Position = (curline/bodlines)*100;
      message->Add(NNTP->LastResponse);
      curline++;
      return;
   }
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::HelpBtnClick(TObject *Sender)
{
   OpenHelp("NNTP",
      "QuickSilver NNTP Mail Retrieval System",
      "QuickSilver NNTP Mail Retrieval System"
   );
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::Tools1Click(TObject *Sender)
{
   AccountManager1->Enabled = !SecureMode;
   Opencurrent1->Enabled = !ServerBox->ItemIndex >= 0;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::About1Click(TObject *Sender)
{
   AnsiString curryear = FormatDateTime("yyyy", Now());
   MsgDlg(this,
      "QSnews v" + ReleaseVer + "\n"
      "Copyright  1999-" + curryear + " by Richard Christman   \n"
      "ALL RIGHTS RESERVED", "About", MB_OK
   );
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::Timer2Timer(TObject *Sender)
{
   Timer2->Enabled = false;

   TStringList *profiles = new TStringList();
   profiles->AddStrings(ServerBox->Items);
   if (RunNewsProfileManager2(this, profiles, dogetnews))
   {
      AnsiString current = ServerBox->Text;
      ServerBox->Clear();
      ServerBox->Items->AddStrings(profiles);
      ServerBox->ItemIndex = ServerBox->Items->IndexOf(current);
   }
   delete profiles;
}
//---------------------------------------------------------------------------
void __fastcall TQSNewsWin::FormShow(TObject *Sender)
{
   if (openaccounts)
   {
      Timer2->Enabled = true;
      openaccounts = false;
   }
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::DrawCheckBox(int x, int y, bool checked)
{
   TCanvas *Canvas = SubList->Canvas;
   Canvas->Rectangle(x, y, x + 12, y + 12);
   if (checked)
   {
      Canvas->MoveTo(x +  2, y + 5);
      Canvas->LineTo(x +  4, y + 7);
      Canvas->LineTo(x + 10, y + 1);
      Canvas->MoveTo(x +  9, y + 3);
      Canvas->LineTo(x +  4, y + 8);
      Canvas->LineTo(x +  1, y + 5);
      Canvas->MoveTo(x +  2, y + 7);
      Canvas->LineTo(x +  4, y + 9);
      Canvas->LineTo(x + 10, y + 3);
   }
}
//---------------------------------------------------------------------------

bool __fastcall IsGroupName(const AnsiString line)
{
   return line.Pos("\255") == 0;
}
//---------------------------------------------------------------------------

bool __fastcall IsESUB(const AnsiString line)
{
   return !GetToken(2, line, "\255").IsEmpty();
}
//---------------------------------------------------------------------------

//bool __fastcall TQSNewsWin::NotTicked(int Index)
//{
//   return SubList->Items->Objects[Index] == 0;
//}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::SubListDrawItem(TWinControl *Control, int Index,
        TRect &Rect, TOwnerDrawState State)
{
   TCanvas *Canvas = SubList->Canvas;
   AnsiString subject, line = SubList->Items->Strings[Index];
   Canvas->FillRect(Rect);

   if (!State.Contains(odSelected))
      Canvas->Pen->Color = clWindowText;
   else
      Canvas->Pen->Color = clWindow;

   if (IsGroupName(line))
   {
      Canvas->TextRect(Rect, Rect.Left + 18, Rect.Top + 1, line);
      goto done;
   }

   subject = GetToken(1, line, "\255");
   if (IsESUB(line))
      subject += "  <es>";

   Canvas->TextRect(Rect, Rect.Left + 30, Rect.Top + 1, subject);

done:
   DrawCheckBox(Rect.Left + 2, Rect.Top + 2, SubListItemChecked(Index));
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::AdjustGroupTick(const AnsiString &group)
{
   bool ok = false;
   for (int i = 0; i < SubList->Items->Count; i++)
   {
      AnsiString item = SubList->Items->Strings[i];
      if (item.Pos(group + "\255") == 1 && SubListItemChecked(i))
      {
         ok = true;
         break;
      }
   }

   int idx = SubList->Items->IndexOf(group);
   assert(idx >= 0);

   SubList->Items->Objects[idx] = (TObject*)ok;
   SubList->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::AdjustGroupTicks()
{
   TStringList *groups = new TStringList();
   for (int i = 0; i < SubList->Items->Count; i++)
   {
      if (IsGroupName(i))
         groups->Add(SubList->Items->Strings[i]);
   }

   for (int i = 0; i < groups->Count; i++)
      AdjustGroupTick(groups->Strings[i]);
   delete groups;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::SaveTick()
{
   TStringList *ticks = new TStringList();
   for (int i = 0; i < SubList->Items->Count; i++)
   {
      if (!SubListItemChecked(i))
         ticks->Add(SubList->Items->Strings[i]);
   }

   PutAppData("notticked", ticks, AppNewsIni);
   delete ticks;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::LoadTick()
{
   TStringList *ticks = new TStringList();
   GetAppData(ticks, "notticked", AppNewsIni); //, AppNewsDat);

   int i = 0; while (i < ticks->Count)
   {
      int idx = SubList->Items->IndexOf(ticks->Strings[i]);
      if (idx >= 0)
      {
         SubList->Items->Objects[idx] = (TObject*)0;
         i++;
      }
      else
         ticks->Delete(i);
   }
   delete ticks;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::SubListMouseDown(TObject *Sender,
        TMouseButton Button, TShiftState Shift, int X, int Y)
{
   mouseX = X;
   mouseY = Y;

   if (mouseX > 14)
      return;

   TPoint p = {mouseX, mouseY};
   int pos = SubList->ItemAtPos(p, true);
   if (pos >= 0)
   {
      bool ticked = SubListItemChecked(pos);
      AnsiString item = SubList->Items->Strings[pos];

      // toggle item tick
      SubList->Items->Objects[pos] = (TObject*)!ticked;

      if (IsGroupName(item))
      {
         for (int i = pos + 1; i < SubList->Items->Count; i++)
         {
            if (SubList->Items->Strings[i].Pos(item + "\255") == 1)
               SubList->Items->Objects[i] = (TObject*)!ticked;
         }

         SubList->Invalidate();
         return;
      }

      AdjustGroupTick(GetToken(0, item, "\255"));
   }
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::SubListDblClick(TObject *Sender)
{
   if (mouseX < 15)
      return;

   int Index = SubList->ItemIndex;
   if (Index >= 0)
   {
      ViewSubject(this, SubList->Items->Strings[Index]);
   }
}
//---------------------------------------------------------------------------

bool __fastcall TQSNewsWin::IsUserItem(int Index)
{
   if (Index < 0)
      return false;

    if (!IsntGroupName(Index))
       return false;

    return !subs->Find(SubList->Items->Strings[Index], NULL);
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::PopupMenu1Popup(TObject *Sender)
{
   int idx = SubList->ItemIndex;
   Edit2->Enabled = IsUserItem(idx);
   View2->Enabled = IsntGroupName(idx);
   Delete1->Enabled = IsUserItem(idx);
}
//---------------------------------------------------------------------------

bool __fastcall TQSNewsWin::IsntGroupName(int Index)
{
   if (Index < 0)
      return false;

   return !IsGroupName(SubList->Items->Strings[Index]);
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::Items1Click(TObject *Sender)
{
   int idx = SubList->ItemIndex;
   Edit1->Enabled = IsUserItem(idx);
   View1->Enabled = IsntGroupName(idx);
   Delete2->Enabled = IsUserItem(idx);
   Reload1->Enabled = !SecureMode;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::New1Click(TObject *Sender)
{
   AnsiString group;
   int index = SubList->ItemIndex;
   if (index >= 0)
      group = GetToken(0, SubList->Items->Strings[index], "\255");
   AnsiString line = NewSubjectManual(this, group);
   if (!line.IsEmpty())
   {
      usubs->Add(line);
      PutAppData("userdata", usubs, AppNewsIni);

      SaveTick();
      LoadSubList();
      LoadTick();
   }
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::Edit1Click(TObject *Sender)
{
   int Index = SubList->ItemIndex;
   assert(Index >= 0);

   AnsiString after, before = SubList->Items->Strings[Index];
   bool tick = SubListItemChecked(Index);
   assert(usubs->Find(before, NULL));

   after = EditSubjectManual(this, before);
   if (!after.IsEmpty())
   {
      usubs->Find(before, Index);
      usubs->Delete(Index);

      usubs->Add(after);
      PutAppData("userdata", usubs, AppNewsIni);
      SubList->Items->AddObject(after, (TObject*)tick);

      SaveTick();
      LoadSubList();
      LoadTick();

      AdjustGroupTick(GetToken(0, after, "\255"));
      SaveTick();
   }
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::View1Click(TObject *Sender)
{
   int idx = SubList->ItemIndex;
   if (idx >= 0)
   {
      ViewSubject(this, SubList->Items->Strings[idx]);
   }
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::Delete2Click(TObject *Sender)
{
   int Index = SubList->ItemIndex;
   assert(Index >= 0);

   if (ConfirmBox(this, "Delete the current item?          ", MB_OKCANCEL) == IDOK)
   {
      AnsiString item = SubList->Items->Strings[Index];
      usubs->Find(item, Index);
      assert(Index >= 0);

      usubs->Delete(Index);
      PutAppData("userdata", usubs, AppNewsIni);

      SaveTick();
      LoadSubList();
      LoadTick();
   }
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::DownloadAllClick(TObject *Sender)
{
   PutAppIni("downloadall", (DownloadAll->Checked ? "1" : "0"), AppNewsIni);
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::ServerBoxChange(TObject *Sender)
{
   int index = ServerBox->ItemIndex;
   if (index >= 0)
   {
      PutAppIni("lastaccount", ServerBox->Items->Strings[index], AppNewsIni);
   }
   ServerBtn->Enabled = index >= 0;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::LoadProxyBox()
{
   ProxyBox->Top = 6;
   ProxyBox->Height = 21;

   AnsiString lastproxy = GetAppIni("lastproxy", "<none>", AppNewsIni);
   ProxyBox->Items->Insert(0, "<none>");

   if (!SecureMode)
   {
      TStringList *proxies = new TStringList();
      GetAppData(proxies, "proxies", AppMainDat);

      for (int i = 0; i < proxies->Count; i++)
      {
         AnsiString line = proxies->Strings[i];
         if (GetToken(5, line, ",") != " ")
            ProxyBox->Items->Add(line);
      }

      if (!lastproxy.IsEmpty() && ProxyBox->Items->IndexOf(lastproxy) < 0)
      {
         MessageBox(Handle,
            AnsiString("The proxy you have been using, '" + GetToken(0, lastproxy, ",") +
                "', has been deleted!    ").c_str(),
            "Warning", MB_OK);
      }

      delete proxies;
   }
   else
   {
      TStringList *proxy = new TStringList();
      GetAppData(proxy, "newsproxy", AppNewsIni);

      AnsiString name = proxy->Values["proxyname"];
      assert(name != "<none>");

      if (!name.IsEmpty())
         ProxyBox->Items->Add(name);

      if (!lastproxy.IsEmpty() && ProxyBox->Items->IndexOf(lastproxy) < 0)
      {
         MessageBox(Handle,
            AnsiString("The proxy you have been using, '" + GetToken(0, lastproxy, ",") +
                "', has been deleted!    ").c_str(),
            "Warning", MB_OK);
      }

      delete proxy;
   }

   ProxyBox->ItemIndex = ProxyBox->Items->IndexOf(lastproxy);
   if (ProxyBox->ItemIndex < 0)
      ProxyBox->ItemIndex = 0;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::ProxyBoxDrawItem(TWinControl *Control, int Index,
        TRect &Rect, TOwnerDrawState State)
{
   TCanvas *Canvas = ProxyBox->Canvas;
   Canvas->FillRect(Rect);

   Canvas->TextRect(Rect, Rect.Left + 2, Rect.Top + 1,
      GetToken(0, ProxyBox->Items->Strings[Index], ","));
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::ProxyBoxChange(TObject *Sender)
{
   PutAppIni("lastproxy", ProxyBox->Items->Strings[ProxyBox->ItemIndex], AppNewsIni);
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::ServerBoxDrawItem(TWinControl *Control, int Index,
        TRect &Rect, TOwnerDrawState State)
{
   TCanvas *Canvas = ServerBox->Canvas;
   Canvas->FillRect(Rect);

   TStringList *item = new TStringList();
   item->CommaText = ServerBox->Items->Strings[Index];

   AnsiString line = item->Values["sort"];
   if (line.IsEmpty())
   {
      line = item->Values["login"];
      if (!line.IsEmpty())
         line += "@";
      line += item->Values["server"];
   }

   Canvas->TextRect(Rect, Rect.Left + 3, Rect.Top + 1, line);
   delete item;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TQSNewsWin::ProfileName()
{
   assert(ServerBox->ItemIndex >= 0);

   TStringList *item = new TStringList();
   item->CommaText = ServerBox->Items->Strings[ServerBox->ItemIndex];

   AnsiString name = item->Values["sort"];
   if (name.IsEmpty())
   {
      name = item->Values["login"];
      if (!name.IsEmpty())
         name += "@";
      name += item->Values["server"];
   }
   delete item;

   return name;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TQSNewsWin::ProfileUserID()
{
   assert(ServerBox->ItemIndex >= 0);

   TStringList *item = new TStringList();
   item->CommaText = ServerBox->Items->Strings[ServerBox->ItemIndex];
   AnsiString userid = item->Values["login"];
   delete item;

   return userid;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TQSNewsWin::ProfilePassword()
{
   assert(ServerBox->ItemIndex >= 0);

   TStringList *item = new TStringList();
   item->CommaText = ServerBox->Items->Strings[ServerBox->ItemIndex];
   AnsiString password = item->Values["password"];
   delete item;

   return password;
}
//---------------------------------------------------------------------------

AnsiString __fastcall TQSNewsWin::ProfileServer()
{
   assert(ServerBox->ItemIndex >= 0);

   TStringList *item = new TStringList();
   item->CommaText = ServerBox->Items->Strings[ServerBox->ItemIndex];
   AnsiString server = item->Values["server"];
   delete item;

   return server;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::SetProfilePassword(const AnsiString &Password)
{
   int index = ServerBox->ItemIndex;
   assert(index >= 0);

   TStringList *profile = new TStringList();
   profile->CommaText = ServerBox->Items->Strings[index];
   profile->Values["password"] = Password;

   AnsiString item = profile->CommaText;
   ServerBox->Items->Delete(index);
   ServerBox->Items->Add(item);
   ServerBox->ItemIndex = ServerBox->Items->IndexOf(item);
   delete profile;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::GetNewsgroups(TStrings *groups)
{
   groups->Clear();

   for (int i = 0; i < SubList->Items->Count; i++)
   {
      AnsiString line = SubList->Items->Strings[i];
      if (IsGroupName(line) && SubListItemChecked(i))
         groups->Add(line);
   }
}
//---------------------------------------------------------------------------

bool __fastcall TQSNewsWin::SubListItemChecked(int Index)
{
   return SubList->Items->Objects[Index] == (TObject*)1;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::GetNewsgroupSubjects(const AnsiString &newsgroup, TStrings *Subjects)
{
   Subjects->Clear();

   bool saving = false;
   for (int i = 0; i < SubList->Items->Count; i++)
   {
      AnsiString subject, password, line = SubList->Items->Strings[i];

      if (!SubListItemChecked(i))
         continue;

      if (IsGroupName(line) && line == newsgroup)
      {
         saving = true;
         continue;
      }

      if (saving && IsGroupName(line))
         break;

      password = GetToken(2, line, "\255");
      subject = GetToken(1, line, "\255");

      if (saving)
      {
         if (!password.IsEmpty())
            subject += "\255" + password;
         Subjects->Add(subject);
      }
   }

 //view(Subjects);
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::SaveProfiles()
{
   PutAppData(NewsProfilesKey2, ServerBox->Items, AppNewsIni);
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::SetProfileNewsgroupLastArticleNum(const AnsiString &newsgroup,
   unsigned lastarticle)
{
   int index = ServerBox->ItemIndex;
   assert(index >= 0);

   TStringList *groups = new TStringList();
   TStringList *profile = new TStringList();

   profile->CommaText = ServerBox->Items->Strings[index];
   groups->CommaText = profile->Values["newsgroups"];
   groups->Values[newsgroup] = IntToStr(lastarticle);
   profile->Values["newsgroups"] = groups->CommaText;
   AnsiString textprofile = profile->CommaText;
   ServerBox->Items->BeginUpdate();
   ServerBox->Items->Delete(index);
   ServerBox->Items->Add(textprofile);
   ServerBox->ItemIndex = ServerBox->Items->IndexOf(textprofile);
   Application->ProcessMessages();
   ServerBox->Items->EndUpdate();
   SaveProfiles();

   delete profile;
   delete groups;
}
//---------------------------------------------------------------------------

unsigned __fastcall TQSNewsWin::ProfileNewsgroupLastArticleNum(const AnsiString &newsgroup)
{
   unsigned lastarticle;
   TStringList *groups = new TStringList();
   TStringList *profile = new TStringList();

   profile->CommaText = ServerBox->Items->Strings[ServerBox->ItemIndex];
   groups->CommaText = profile->Values["newsgroups"];
   lastarticle = groups->Values[newsgroup].ToIntDef(0);

   delete profile;
   delete groups;

   return lastarticle;
}
//---------------------------------------------------------------------------

bool __fastcall TQSNewsWin::IsNewsgroupSubjectMatch(const AnsiString &newsgroup, TStrings *message)
{
   THeaderManager *hm = new THeaderManager(message);
   AnsiString sub, rawsub, key, subject = hm->GetDat("Subject: ");
   delete hm;

   bool match = false;
   for (int i = 0; i < groupsubjects->Count; i++)
   {
      rawsub = groupsubjects->Strings[i];
      if (rawsub.Pos("\255") > 1)
      {
         sub = GetToken(0, rawsub, "\255");
         key = GetToken(1, rawsub, "\255");

         if (TestSubject(subject, sub, key) == 0)
         {
            THeadMan *headers = new THeadMan(message);
            int idx = headers->Delete("Subject: ");
            message->Insert(idx, "Subject: " + sub + " " + esub);
            delete headers;
            match = true;
            break;
         }
      }

      if (rawsub == subject)
      {
         match = true;
         break;
      }
   }

   return match;
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::Opencurrent1Click(TObject *Sender)
{
   int index = ServerBox->ItemIndex;
   assert(index >= 0);

   AnsiString item = ServerBox->Items->Strings[index];
   if (EditAccountProfile2(this, item))
   {
      ServerBox->Items->Delete(index);
      ServerBox->Items->Add(item);
      ServerBox->ItemIndex = ServerBox->Items->IndexOf(item);
      SaveProfiles();
   }
}
//---------------------------------------------------------------------------

AnsiString __fastcall TQSNewsWin::GetNextNewsgroup(int currGroup)
{
   TrimNulls(newsgroups);
   if (currGroup < newsgroups->Count)
      return newsgroups->Strings[currGroup];

   return "";
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::ResetBtnClick(TObject *Sender)
{
   if (!SubList->Visible)
   {
      SubList->Show();
      DisplayMemo->Hide();

      GetBtn->Enabled = true;
      GetBtn->Show();
      ResetBtn->Hide();
      return;
   }
}
//---------------------------------------------------------------------------

void __fastcall TQSNewsWin::Reload1Click(TObject *Sender)
{
   DisplayMemo->Clear();
   SubList->Clear();
   SubList->Show();
   DisplayMemo->Hide();
   Snooze(200);

   TStringList *subs = new TStringList();
   subs->Sorted = true;
   GetNymNewsgroupsSubjectsFromQS(subs);
   PutAppData("nymdata", subs, AppNewsIni);
   delete subs;

   LoadSubList();
   Snooze(200);
}
//---------------------------------------------------------------------------


